/**
 *	@file	?.cpp
 *	@brief
 *	@author	tenk*
 *	@date	200?-??
 *	@note
 *		ႢR}hCc[p̐`.
 */

#include "../file_hdl.h"

#include <stdio.h>
#include <stdlib.h>
#include <vector>
#include <string>

#define uint64_t	unsigned long long

/** C.
 */
int main()
{
  #if 1
	{
		FILE_HDL	hdl = file_open_w("tmp.bin");
		assert(hdl != FILE_ERR_HDL);
		char buf[ 1024 ];
		memset(buf, 'A', sizeof buf);
		file_write(hdl, buf, sizeof buf);
		file_close(hdl);

		memset(buf, 0, sizeof buf);
		hdl = file_open_r("tmp.bin");
		assert(hdl != FILE_ERR_HDL);
		file_read(hdl, buf, sizeof buf);
		assert(file_getSize(hdl) == 1024);
		int tel = (int)file_tell(hdl);
		assert(tel == 1024);
		assert(file_seek(hdl, 0, 0) == 0);
		file_time_t	c = 0, a = 0, w = 0;
		file_getTime(hdl, &c, &a, &w);
		file_setTime(hdl, c, a, w);
		file_close(hdl);
		assert(buf[0] == 'A' && buf[1023] == 'A');

		hdl = file_open_w("tmp.tmp");
		file_puts("test.tmp\r\ntest\r\n", hdl);
		file_printf(hdl,"%d\r\n", 999);
		file_close(hdl);
		hdl = file_open_r("tmp.tmp");
		const char* tt = "test.tmp\r\ntest\r\n999\r\n";
		unsigned sz = file_read(hdl, buf, sizeof buf);
		assert(sz == strlen(tt));
		assert(memcmp(buf, tt, strlen(tt)) == 0);
	}
  #endif
  #if 0
	{
		enum {L = 256};
		FILE_HDL	hdl[L] = {0};
		for (unsigned j = 0; j < 16; ++j) {
			for (unsigned i = 0; i < L; ++i) {
				char buf[2000];
				sprintf(buf, "tmp_j%04di%04d.bak", j, i);
				hdl[i] = file_open_w(buf);
				assert(hdl[i] > (HANDLE)2);
				file_puts(buf, hdl[i]);
				sprintf(buf, "hdl=%#8x\n", hdl[i]);
				file_puts(buf, hdl[i]);
				file_printf(FILE_HDL_STDOUT, "%s", buf);
			}
			for (unsigned i = 0; i < L; ++i) {
				file_close(hdl[i]);
				hdl[i] = FILE_ERR_HDL;
			}
		}
	}
  #endif
	return 0;
}
